void loadtape(std::string sfnam) {
//	std::string sfnam = std::string(fname.toUtf8().data());
	QString fnam(sfnam.c_str());
	if (fnam.endsWith(".tap",Qt::CaseInsensitive)) tape.load(sfnam,TYPE_TAP);
	if (fnam.endsWith(".tzx",Qt::CaseInsensitive)) tape.load(sfnam,TYPE_TZX);
}

void savetape(std::string sfnam, bool select=true) {
	QString fnam(sfnam.c_str());
	if (select) {
		fnam = fdial->save(NULL,"Save tape",fnam,QStringList()<<"Tape image (*.tap)").selfile;
		sfnam = std::string(fnam.toUtf8().data());
	}
	if (sfnam=="") return;
	if (!fnam.endsWith(".tap",Qt::CaseInsensitive)) sfnam.append(".tap");
	tape.save(sfnam,TYPE_TAP);
	tape.path=sfnam;
}

void loaddisk(std::string sfnam, unsigned char drv=0) {
	QString fnam(sfnam.c_str());
	if (fnam.endsWith(".trd",Qt::CaseInsensitive)) flop[drv].load(sfnam,TYPE_TRD);
	if (fnam.endsWith(".scl",Qt::CaseInsensitive)) flop[drv].load(sfnam,TYPE_SCL);
}

void loadsomefile(std::string sfnam,unsigned char drv=0) {
	QString fnam(sfnam.c_str());
	if (fnam.endsWith(".sna",Qt::CaseInsensitive)) loadsna(sfnam);
	if (fnam.endsWith(".tap",Qt::CaseInsensitive)) tape.load(sfnam,TYPE_TAP);
	if (fnam.endsWith(".tzx",Qt::CaseInsensitive)) tape.load(sfnam,TYPE_TZX);
	if (fnam.endsWith(".trd",Qt::CaseInsensitive)) flop[drv].load(sfnam,TYPE_TRD);
	if (fnam.endsWith(".scl",Qt::CaseInsensitive)) flop[drv].load(sfnam,TYPE_SCL);
}

void opensomewhat() {
	emulwin->setpause(true);
	QStringList filters; filters<<"Known formats (*.sna *.trd *.scl *.tap *.tzx)"<<"Disk B (*.trd *.scl)"<<"Disk C (*.trd *.scl)"<<"Disk D (*.trd *.scl)";
	MFResult res = fdial->open(NULL,"Open somewhat","",filters);
	if (res.selfile!="") {
		std::string sfnam(res.selfile.toUtf8().data());
		uchar drv = res.fidx;
		loadsomefile(sfnam,drv);
	}
	emulwin->setpause(false);
}

// SAVE

bool savedisk(std::string sfnam, unsigned char drv=0,bool sel=true) {
	if (!flop[drv].insert) return true;
	QString fnam(sfnam.c_str());
	if (sel) {
		fnam = fdial->save(0,QString("Save disk ").append(QChar(0x41+drv)).append(":"),fnam,QStringList()<<"Disk image (*.trd *.scl)").selfile;
		sfnam = std::string(fnam.toUtf8().data());
	}
	if (sfnam!="") {
		bool kformat=false;
		if (fnam.endsWith(".trd",Qt::CaseInsensitive)) {flop[drv].save(sfnam,TYPE_TRD); kformat=true;}
		if (fnam.endsWith(".scl",Qt::CaseInsensitive)) {flop[drv].save(sfnam,TYPE_SCL); kformat=true;}
		if (!kformat) {fnam.append(".trd"); flop[drv].save(sfnam,TYPE_TRD);}
		flop[drv].path=sfnam;
		flop[drv].changed=false;
	}
	return (sfnam!="");
}

void saveonf2() {
	QStringList filter;
	if (flop[0].insert) {filter<<"Disk A (*.trd *scl)";}
	if (tape.data.size()!=0) {filter<<"Tape (*.tap)";}
	filter<<"Snapshot (*.sna)";
	MFResult res = fdial->save(0,"Save something","",filter);
	if (res.selfile!="") {
		std::string sfnam(res.selfile.toUtf8().data());
		QString filt = res.selfilt;
		if (filt.indexOf("Snapshot")!=-1) savesnapshot(sfnam, machine==&machlist[0]);
		if (filt.indexOf("Disk A")!=-1) savedisk(sfnam,0,false);
		if (filt.indexOf("Tape")!=-1) savetape(sfnam,false);
	}
}

MFResult MFDialog::save(QWidget* par,QString name,QString dir,QStringList filt) {
	setAcceptMode(QFileDialog::AcceptSave);
	setConfirmOverwrite(true);
	return execute(par,name,dir,filt);
}

MFResult MFDialog::open(QWidget* par,QString name,QString dir,QStringList filt) {
	setAcceptMode(QFileDialog::AcceptOpen);
	return execute(par,name,dir,filt);
}

MFResult MFDialog::execute(QWidget* par,QString name,QString dir,QStringList filt) {
	MFResult res;
	res.selfile = "";
	res.selfilt = "";
	res.fidx = -1;
	setParent(par);
	setWindowTitle(name);
	if (dir=="") setDirectory(lastdir); else setDirectory(dir);
	setNameFilters(filt);
	setOption(QFileDialog::DontUseNativeDialog,false);
	if (exec()) {
		res.selfilt = selectedNameFilter();
		res.fidx = filt.indexOf(res.selfilt);
		res.selfile = selectedFiles()[0];
		if (dir=="") lastdir = directory().absolutePath();
	}
	return res;
}
