SetupWin::SetupWin(QWidget *parent=0):QDialog(parent) {

	QVBoxLayout *mainlay = new QVBoxLayout;
	QHBoxLayout *dnlay = new QHBoxLayout;

	uint i;

//--- machines
	QWidget *macwidget = new QWidget;
	QVBoxLayout *maclay = new QVBoxLayout;

	QGridLayout *macuplay = new QGridLayout;
	QLabel *machcblab = new QLabel("Machine");
	machcombox = new QComboBox;
	resetmach = new QCheckBox("Reset");
	QLabel *rsetlab = new QLabel("Romset");
	rsetcombox = new QComboBox;

	macuplay->addWidget(machcblab,0,0);
	macuplay->addWidget(machcombox,0,1);
	macuplay->addWidget(resetmach,0,2);
	macuplay->addWidget(rsetlab,1,0);
	macuplay->addWidget(rsetcombox,1,1);
	macuplay->setColumnStretch(1,100);

	listrom = new QListView;
	listrom->setEditTriggers(QListView::NoEditTriggers);

	maclay->addLayout(macuplay);
	maclay->addWidget(listrom);
	maclay->addStretch();
	macwidget->setLayout(maclay);

	QObject::connect(machcombox,SIGNAL(currentIndexChanged(int)),this,SLOT(setrsetcombox(int)));
	QObject::connect(rsetcombox,SIGNAL(currentIndexChanged(int)),this,SLOT(updateromset(int)));

//--- dos
	QWidget *doswidget = new QWidget;
	QVBoxLayout *doslay = new QVBoxLayout;
	QGridLayout *alslay = new QGridLayout;

	bdien = new QCheckBox("BetaDisk enabled");
	dskten = new QCheckBox("Turbo disk speed");

	QTabWidget *disks = new QTabWidget;
	QWidget *diskwid;
	QVBoxLayout *diskmay;
	QGridLayout *diskset;
	QHBoxLayout *disklay,*ddsklay;
	for(i=0;i<4;i++) {
		diskwid = new QWidget;
		diskmay = new QVBoxLayout;
		diskset = new QGridLayout;
		disklay = new QHBoxLayout;
		ddsklay = new QHBoxLayout;
		diskname[i] = new QLineEdit;
		diskname[i]->setReadOnly(true);
		loadisk[i] = new QToolButton;
		loadisk[i]->setText("Load");
		savdisk[i] = new QToolButton;
		savdisk[i]->setText("Save");
		ejcdisk[i] = new QToolButton;
		ejcdisk[i]->setText("Eject");
		dskprt[i]=new QCheckBox("Write protect");
		dsk80[i]=new QCheckBox("80 cylinders");
		dskss[i]=new QCheckBox("Double side");
//		dskss[i]->setEnabled(false);			// пока оно не действует (?)
		disklay->addWidget(diskname[i]);
		ddsklay->addStretch();
		ddsklay->addWidget(loadisk[i]);
		ddsklay->addWidget(savdisk[i]);
		ddsklay->addWidget(ejcdisk[i]);
		diskset->addWidget(dskprt[i],0,0);
		diskset->addWidget(dsk80[i],0,1);
		diskset->addWidget(dskss[i],0,2);
		diskmay->addLayout(disklay);
		diskmay->addLayout(ddsklay);
		diskmay->addLayout(diskset);
		diskmay->addStretch();
		diskwid->setLayout(diskmay);
		disks->addTab(diskwid,QString(QChar('A'+i)).append(":"));
	}
//	disks->addTab(diskwid[0],"A:");disks->addTab(diskwid[1],"B:");
//	disks->addTab(diskwid[2],"C:");disks->addTab(diskwid[3],"D:");

	alslay->addWidget(bdien,0,0);
	alslay->addWidget(dskten,1,0);
	doslay->addLayout(alslay);
	doslay->addWidget(disks);
	doslay->addStretch();
	doswidget->setLayout(doslay);

	QObject::connect(loadisk[0],SIGNAL(released()),this,SLOT(opendiska()));
	QObject::connect(loadisk[1],SIGNAL(released()),this,SLOT(opendiskb()));
	QObject::connect(loadisk[2],SIGNAL(released()),this,SLOT(opendiskc()));
	QObject::connect(loadisk[3],SIGNAL(released()),this,SLOT(opendiskd()));
	QObject::connect(savdisk[0],SIGNAL(released()),this,SLOT(savediska()));
	QObject::connect(savdisk[1],SIGNAL(released()),this,SLOT(savediskb()));
	QObject::connect(savdisk[2],SIGNAL(released()),this,SLOT(savediskc()));
	QObject::connect(savdisk[3],SIGNAL(released()),this,SLOT(savediskd()));
	QObject::connect(ejcdisk[0],SIGNAL(released()),this,SLOT(ejctdiska()));
	QObject::connect(ejcdisk[1],SIGNAL(released()),this,SLOT(ejctdiskb()));
	QObject::connect(ejcdisk[2],SIGNAL(released()),this,SLOT(ejctdiskc()));
	QObject::connect(ejcdisk[3],SIGNAL(released()),this,SLOT(ejctdiskd()));


//--- tape
	QWidget *tapwidget = new QWidget;
	QVBoxLayout *taplay = new QVBoxLayout;
	QHBoxLayout *tapl1 = new QHBoxLayout;
	QHBoxLayout *tapl2 = new QHBoxLayout;
	QVBoxLayout *tapl2r = new QVBoxLayout;

	tapname = new QLineEdit;
	seltapbut = new QToolButton;
	savtapbut = new QToolButton;
	clrtapbut = new QToolButton;
	seltapbut->setText("Load");
	savtapbut->setText("Save");
	clrtapbut->setText("Eject");
	tapname->setReadOnly(true);
	tapl1->addStretch();
	tapl1->addWidget(seltapbut);
	tapl1->addWidget(savtapbut);
	tapl1->addWidget(clrtapbut);

	listtape = new MyListView;
	listtape->setEditTriggers(QListView::NoEditTriggers);
	deltblock = new QPushButton("Delete");
	tblockup = new QPushButton("Up");
	tblockdn = new QPushButton("Down");

	tapl2r->addWidget(tblockup);
	tapl2r->addWidget(tblockdn);
	tapl2r->addWidget(deltblock);
	tapl2r->addStretch();
	tapl2->addWidget(listtape);
	tapl2->addLayout(tapl2r);

	tapblock = new QLineEdit;
	tapblock->setReadOnly(true);

	taplay->addWidget(tapname);
	taplay->addLayout(tapl1);
	taplay->addLayout(tapl2);
	taplay->addWidget(tapblock);
	taplay->addStretch();
	tapwidget->setLayout(taplay);

	QObject::connect(seltapbut,SIGNAL(released()),this,SLOT(opentape()));
	QObject::connect(savtapbut,SIGNAL(released()),this,SLOT(writetape()));
	QObject::connect(clrtapbut,SIGNAL(released()),this,SLOT(ejecttape()));
	QObject::connect(tblockup,SIGNAL(released()),this,SLOT(tapeblockup()));
	QObject::connect(tblockdn,SIGNAL(released()),this,SLOT(tapeblockdn()));
	QObject::connect(deltblock,SIGNAL(released()),this,SLOT(deletetapeblock()));
	QObject::connect(listtape,SIGNAL(doubleClicked(QModelIndex)),this,SLOT(setcurtapeblock()));

//--- video
	QWidget *vidwidget = new QWidget;
	QVBoxLayout *vidlay = new QVBoxLayout;
	QGridLayout *vidgridup = new QGridLayout;
	QGridLayout *vidgriddn = new QGridLayout;

	dblsize = new QCheckBox("Double size");
	fscrn = new QCheckBox("FullScreen");
	sshotbrd = new QCheckBox("Border in screenshots");
	sshotbrd->setEnabled(false);

	QLabel *brdlab = new QLabel("Border size");
	brdsld = new QSlider(Qt::Horizontal);
	brdsld->setMinimum(0);
	brdsld->setMaximum(100);
	brdsld->setTickInterval(10);
	brdsld->setTickPosition(QSlider::TicksBelow);
	brdshow = new QLabel;
	// screenshotbox
	QGroupBox *sshbox = new QGroupBox("Screenshots");
	QVBoxLayout *scrshotlay = new QVBoxLayout;
	QHBoxLayout *shfldlay = new QHBoxLayout;
	QLabel *sshotlab2 = new QLabel("Folder");
	sshotfld = new QLineEdit;
	sshotfld->setReadOnly(true);
	setsshfld = new QToolButton;
	setsshfld->setText("...");
	shfldlay->addWidget(sshotlab2);
	shfldlay->addWidget(sshotfld);
	shfldlay->addWidget(setsshfld);

	QHBoxLayout *autoshot = new QHBoxLayout;
	QLabel *screplab = new QLabel("Repeating. (count x interval)");
	screpcount = new QSpinBox;
	screptime = new QSpinBox;
	screpcount->setRange(1,9999);
	screptime->setRange(1,250);
	autoshot->addWidget(screplab);
	autoshot->addWidget(screpcount);
	autoshot->addWidget(screptime);

	QHBoxLayout *sshfrmlay = new QHBoxLayout;
	QLabel *sshotlab1 = new QLabel("Picture format");
	sshotformbox = new QComboBox;
	flist.clear(); flist<<"bmp"<<"jpg"<<"png"<<"scr";
	sshotformbox->addItems(flist);
	
	sshfrmlay->addWidget(sshotlab1);
	sshfrmlay->addWidget(sshotformbox);

	scrshotlay->addLayout(shfldlay);
	scrshotlay->addLayout(autoshot);
	scrshotlay->addLayout(sshfrmlay);
	sshbox->setLayout(scrshotlay);
	//---
	vidgridup->addWidget(dblsize,0,0);
	vidgridup->addWidget(sshotbrd,0,1);
	vidgridup->addWidget(fscrn,1,0);

	vidgriddn->addWidget(brdlab,0,0);
	vidgriddn->addWidget(brdsld,0,1);
	vidgriddn->addWidget(brdshow,0,2);

	vidlay->addLayout(vidgridup);
	vidlay->addLayout(vidgriddn);
	vidlay->addWidget(sshbox);
	vidlay->addStretch();
	vidwidget->setLayout(vidlay);

	QObject::connect(brdsld,SIGNAL(valueChanged(int)),this,SLOT(updateall()));
	QObject::connect(setsshfld,SIGNAL(released()),this,SLOT(choosesshfolder()));

//--- sound
	QWidget	*sndwidget = new QWidget;
	QVBoxLayout *sndlay = new QVBoxLayout;
	QGridLayout *sndulay = new QGridLayout;
	QGridLayout *sndgrid = new QGridLayout;

	snden = new QCheckBox("Sound enabled");
	insndchk = new QCheckBox("Don't mute if inactive");
	sndulay->addWidget(snden,0,0);
	sndulay->addWidget(insndchk,0,1);

	QLabel *ssyslab = new QLabel("Output sys");
	sndsysbox = new QComboBox;
	for(i=0;i<soundsyslist.size();i++) sndsysbox->addItem(QString(soundsyslist[i].name.c_str()));

	QLabel *sratelab = new QLabel("Output rate");
	sndrate = new QComboBox;
	for(i=0;i<3;i++) sndrate->addItem(QString::number(sndfreqs[i]));
//sndrate->setEnabled(false);		// пока не работает

	QLabel *sndlab1 = new QLabel("Sound Buffer");
	sblensld = new QSlider(Qt::Horizontal);
	sblensld->setMinimum(190);
	sblensld->setMaximum(210);
	sblensld->setTickInterval(2);
	sblensld->setTickPosition(QSlider::TicksBelow);
	sblenshow = new QLabel;

	QLabel *sndlab2 = new QLabel("Beep Volume");
	beepsld = new QSlider(Qt::Horizontal);
	beepsld->setMinimum(0);
	beepsld->setMaximum(16);
	beepsld->setTickInterval(2);
	beepsld->setTickPosition(QSlider::TicksBelow);
	beepshow = new QLabel;

	QLabel *sndlab3 = new QLabel("Tape Volume");
	tapesld = new QSlider(Qt::Horizontal);
	tapesld->setMinimum(0);
	tapesld->setMaximum(16);
	tapesld->setTickInterval(2);
	tapesld->setTickPosition(QSlider::TicksBelow);
	tapeshow = new QLabel;

	QLabel *sndlab4 = new QLabel("AY/YM Volume");
	aysld = new QSlider(Qt::Horizontal);
	aysld->setMinimum(0);
	aysld->setMaximum(16);
	aysld->setTickInterval(2);
	aysld->setTickPosition(QSlider::TicksBelow);
	ayshow = new QLabel;

	sblensld->setValue(int(sndbuflen*10));
	beepsld->setValue(beepvolume);
	tapesld->setValue(tapevolume);
	aysld->setValue(ayvolume);

	sndgrid->addWidget(ssyslab,0,0);
	sndgrid->addWidget(sndsysbox,0,1);
	sndgrid->addWidget(sratelab,1,0);
	sndgrid->addWidget(sndrate,1,1);
	sndgrid->addWidget(sndlab1,2,0);
	sndgrid->addWidget(sblensld,2,1);
	sndgrid->addWidget(sblenshow,2,2);
	sndgrid->addWidget(sndlab2,3,0);
	sndgrid->addWidget(beepsld,3,1);
	sndgrid->addWidget(beepshow,3,2);
	sndgrid->addWidget(sndlab3,4,0);
	sndgrid->addWidget(tapesld,4,1);
	sndgrid->addWidget(tapeshow,4,2);
	sndgrid->addWidget(sndlab4,5,0);
	sndgrid->addWidget(aysld,5,1);
	sndgrid->addWidget(ayshow,5,2);
	sndgrid->setColumnStretch(1,100);

	sndlay->addLayout(sndulay);
	sndlay->addLayout(sndgrid);
	sndlay->addStretch();
	sndwidget->setLayout(sndlay);

	QObject::connect(sblensld,SIGNAL(valueChanged(int)),this,SLOT(updateall()));
	QObject::connect(beepsld,SIGNAL(valueChanged(int)),this,SLOT(updateall()));
	QObject::connect(tapesld,SIGNAL(valueChanged(int)),this,SLOT(updateall()));
	QObject::connect(aysld,SIGNAL(valueChanged(int)),this,SLOT(updateall()));
//--- integration
	QWidget *intewid = new QWidget;
	QVBoxLayout *intelay = new QVBoxLayout;
		QHBoxLayout *sjalay = new QHBoxLayout;
			QLabel *sjalab = new QLabel("SJAsm path");
			sjaline = new QLineEdit;
			sjasel = new QToolButton; sjasel->setText("...");
			sjalay->addWidget(sjalab);
			sjalay->addWidget(sjaline,10);
			sjalay->addWidget(sjasel);
		QGroupBox *menbox = new QGroupBox("User menu");
			QHBoxLayout *menlay = new QHBoxLayout;
				menlist = new QListView;
					menlist->setEditTriggers(QListView::NoEditTriggers);
					menlist->setSelectionMode(QListView::SingleSelection);
				QVBoxLayout *mentlay = new QVBoxLayout;
					addmen = new QToolButton; addmen->setText("Add");
					delmen = new QToolButton; delmen->setText("Del");
					mentlay->addWidget(addmen);
					mentlay->addWidget(delmen);
					mentlay->addStretch();
				menlay->addWidget(menlist,10);
				menlay->addLayout(mentlay);
			menbox->setLayout(menlay);
		intelay->addLayout(sjalay);
		intelay->addWidget(menbox);
		intelay->addStretch();
	intewid->setLayout(intelay);
	
	umendial = new QDialog(this);
	QVBoxLayout *umdlay = new QVBoxLayout;
		QGridLayout *umdulay = new QGridLayout;
			QLabel *lab = new QLabel("Name"); umdname = new QLineEdit;
				umdulay->addWidget(lab,0,0); umdulay->addWidget(umdname,0,1);
			lab = new QLabel("Path"); umdpath = new QLineEdit; umdpath->setReadOnly(true);
				umdsel = new QToolButton; umdsel->setText("...");
				umdulay->addWidget(lab,1,0); umdulay->addWidget(umdpath,1,1); umdulay->addWidget(umdsel,1,2);
			umdulay->setColumnStretch(1,10);
		QHBoxLayout *umddlay = new QHBoxLayout;
			umdok = new QPushButton("OK");
			umdcan = new QPushButton("Cancel");
			umddlay->addStretch();
			umddlay->addWidget(umdok);
			umddlay->addWidget(umdcan);
		umdlay->addLayout(umdulay);
		umdlay->addLayout(umddlay);
	umendial->setLayout(umdlay);

	QObject::connect(sjasel,SIGNAL(released()),this,SLOT(selsjapath()));
	QObject::connect(addmen,SIGNAL(released()),this,SLOT(addnewumen()));
	QObject::connect(delmen,SIGNAL(released()),this,SLOT(delusermen()));
	QObject::connect(umdok,SIGNAL(released()),this,SLOT(applyaddumen()));
	QObject::connect(umdcan,SIGNAL(released()),umendial,SLOT(hide()));
	QObject::connect(umdsel,SIGNAL(released()),this,SLOT(selumdpath()));
	QObject::connect(menlist,SIGNAL(doubleClicked(QModelIndex)),this,SLOT(editumen(QModelIndex)));

//--- bottom
	okbut = new QPushButton(QIcon(":images/ok-apply.png"),"OK");
	applbut = new QPushButton(QIcon(":images/ok-apply.png"),"Apply");
	canbut = new QPushButton(QIcon(":images/cancel.png"),"Cancel");
	dnlay->addStretch();
	dnlay->addWidget(okbut);
	dnlay->addWidget(applbut);
	dnlay->addWidget(canbut);

	tabz = new QTabWidget;
	tabz->addTab(macwidget,QIcon(":images/laptop.png"),QString("Machine"));
	tabz->addTab(vidwidget,QIcon(":images/display.png"),QString("Video"));
	tabz->addTab(sndwidget,QIcon(":images/speaker.png"),QString("Sound"));
	tabz->addTab(doswidget,QIcon(":images/terminal.png"),QString("DOS"));
	tabz->addTab(tapwidget,QIcon(":images/tape.png"),QString("Tape"));
	tabz->addTab(intewid,QIcon(":images/other.png"),QString("Tools"));

	mainlay->addWidget(tabz);
	mainlay->addLayout(dnlay);

	setLayout(mainlay);
	setWindowIcon(QIcon(":/images/logo.svg"));
	setWindowTitle("Xpeccy setup");
	setMinimumWidth(500);


	QObject::connect(canbut,SIGNAL(released()),this,SLOT(reject()));
	QObject::connect(applbut,SIGNAL(released()),this,SLOT(applysettings()));
	QObject::connect(okbut,SIGNAL(released()),this,SLOT(okexit()));

}

void SetupWin::selsjapath() {
	QString fpath = QFileDialog::getOpenFileName(this,"Select SJAsm+ ELF",QString(sjapath.c_str()),"All files (*)");
	if (fpath!="") sjaline->setText(fpath);
}

void SetupWin::gosetup() {
	emulwin->setpause(true);;

	settapelist();
	temptapeblock=tape.block;
	tapname->setText(QDialog::trUtf8(tape.path.c_str()));
	tapblock->setText(listtape->model()->data(listtape->model()->index(temptapeblock,0)).toString());

	uchar i;
	for (i=0;i<4;i++) {
		diskname[i]->setText(QDialog::trUtf8(flop[i].path.c_str()));
		dskprt[i]->setChecked(flop[i].protect);
		dsk80[i]->setChecked(flop[i].trk80);
		dskss[i]->setChecked(flop[i].dblsid);
	}
	if (machcombox->currentIndex()==-1) {for (i=0;i<machlist.size();i++) {machcombox->addItem(QString(machlist[i].name.c_str()));}}	// забиваем только 1 раз
	machcombox->setCurrentIndex(curmachine);
	resetmach->setChecked(resetafterchange);
	if (rsetcombox->currentIndex()==-1) {for (i=0;i<romslist.size();i++) {rsetcombox->addItem(QString(romslist[i].name.c_str()));}}
	rsetcombox->setCurrentIndex(getromsetindex(machlist[curmachine].romset->name));
	updateromset(getromsetindex(machlist[curmachine].romset->name));

	snden->setChecked(soundenabled);
	insndchk->setChecked(inactivesnd);
	sblensld->setValue(int(sndbuflen*10));
	beepsld->setValue(beepvolume);
	tapesld->setValue(tapevolume);
	aysld->setValue(ayvolume);
	brdsld->setValue(bordersize);
	bdien->setChecked(bdi.enable);
	dskten->setChecked(bdi.turbo);
	dblsize->setChecked(doublesize); fscrn->setChecked(fullscrn);
	sndrate->setCurrentIndex(cursndfreq);
	sndsysbox->setCurrentIndex(cursndsys);
	sshotfld->setText(QString(screenshotdir.c_str()));
	sshotformbox->setCurrentIndex(flist.indexOf(QString(screenshotformat.c_str())));
	sshotbrd->setChecked(borderinscreenshot);
	screptime->setValue(sshotrpttime);
	screpcount->setValue(sshotrptcount);

	sjaline->setText(QString(sjapath.c_str()));
	tumlist = usermenu;
	formumlist();

	updateall();
	show();
}

void SetupWin::setrsetcombox(int num) {rsetcombox->setCurrentIndex(getromsetindex(machlist[num].romset->name));}

void SetupWin::updateromset(int num) {
	QStringListModel *model = new QStringListModel;
	QString element;
	QStringList list;
	QStringList romnames = QStringList()<<"Basic48"<<"Basic128"<<"Shadow"<<"DOS"<<"ext4"<<"ext5"<<"ext6"<<"ext7";
	for (tmp=0;tmp<8;tmp++) {
		element = romnames[tmp];
		if (romslist[num].path[tmp]!="") element.append("\t").append(romslist[num].path[tmp].c_str()).append(":").append(QString::number(romslist[num].part[tmp]));
		list<<element;
	}
	model->setStringList(list);
	listrom->setModel(model);
}

void SetupWin::updateall() {
	QString strg;
	QStringList brds;
	brds<<"None"<<"Half"<<"Full";
	sblenshow->setText(strg.setNum((sblensld->value())*0.1,'f',1).append("ms"));
	beepshow->setText(strg.number(beepsld->value()));
	tapeshow->setText(strg.number(tapesld->value()));
	ayshow->setText(strg.number(aysld->value()));
	brdshow->setText(strg.number(brdsld->value()).append("%"));
}

void SetupWin::reject() {emulwin->setpause(false); hide();}

void SetupWin::okexit() {
	applysettings();
	savesettings();
	emulwin->setpause(false);
	hide();
}

void SetupWin::applysettings() {
	unsigned char i;

	if (temptapeblock!=tape.block) {tape.block = temptapeblock; tape.pos=0;}

	unsigned char oldmachine = curmachine;
	RomSet *oldrset = machlist[curmachine].romset;
	RomSet *newrset = &romslist[rsetcombox->currentIndex()];
	curmachine = machcombox->currentIndex();
	machine = &machlist[curmachine];
//	for (i=0;i<8;i++) {newrset->path[i]=romfilename[i]->text();newrset->part[i]=romfilepart[i]->value();}
	loadmachineromset();
	resetafterchange = resetmach->isChecked();
	machlist[curmachine].romset = newrset;
	loadmachineromset();
	if (((curmachine != oldmachine) or (machlist[curmachine].romset != oldrset)) and resetafterchange) reset();

	inactivesnd = insndchk->isChecked();
	soundenabled = snden->isChecked();
	beepvolume = beepsld->value();
	tapevolume = tapesld->value();
	ayvolume = aysld->value();

	doublesize=dblsize->isChecked();
	fullscrn=fscrn->isChecked();
	bordersize = brdsld->value(); setbordersize(bordersize/100.0);

	screenshotdir = std::string(sshotfld->text().toUtf8().data());
	screenshotformat = std::string(sshotformbox->currentText().toUtf8().data());
	borderinscreenshot = sshotbrd->isChecked();
	sshotrpttime = screptime->value();
	sshotrptcount = screpcount->value();

	sndbuflen = (sblensld->value())*0.1;
	bufsize=int(rate*chanels*sndbuflen/1000);
	if (cursndsys!=sndsysbox->currentIndex() || cursndfreq!=sndrate->currentIndex()) {
		cursoundsys->close();
		cursndsys=sndsysbox->currentIndex(); cursoundsys=&soundsyslist[cursndsys];
		cursndfreq = sndrate->currentIndex(); defsoundparamz();
		if (!cursoundsys->open()) {
			QMessageBox mbx; mbx.setIcon(QMessageBox::Critical);
			mbx.setText("Open sound device failed");
			mbx.setInformativeText("Reset to NULL audio output");
			mbx.exec();
			cursndsys=0;
			cursoundsys = &soundsyslist[0];
		}
	}
	bdi.enable=bdien->isChecked();
	bdi.turbo=dskten->isChecked();
	for (i=0;i<4;i++) {
		flop[i].protect=dskprt[i]->isChecked();
		flop[i].trk80=dsk80[i]->isChecked();
		flop[i].dblsid=dskss[i]->isChecked();
	}
	sjapath = std::string(sjaline->text().toUtf8().data());
	usermenu = tumlist;
	((EmulWindow*)parent())->makemenu();
}

void SetupWin::savediska() {savedisk(flop[0].path,0);diskname[0]->setText(flop[0].path.c_str());}
void SetupWin::savediskb() {savedisk(flop[1].path,1);diskname[1]->setText(flop[1].path.c_str());}
void SetupWin::savediskc() {savedisk(flop[2].path,2);diskname[2]->setText(flop[2].path.c_str());}
void SetupWin::savediskd() {savedisk(flop[3].path,3);diskname[3]->setText(flop[3].path.c_str());}

void SetupWin::ejctdiska() {if (flop[0].eject()) diskname[0]->setText("");}
void SetupWin::ejctdiskb() {if (flop[1].eject()) diskname[1]->setText("");}
void SetupWin::ejctdiskc() {if (flop[2].eject()) diskname[2]->setText("");}
void SetupWin::ejctdiskd() {if (flop[3].eject()) diskname[3]->setText("");}

void SetupWin::opendiska() {opendisk(0);}
void SetupWin::opendiskb() {opendisk(1);}
void SetupWin::opendiskc() {opendisk(2);}
void SetupWin::opendiskd() {opendisk(3);}

void SetupWin::opendisk(unsigned char drv) {
	QString fnam = QFileDialog::getOpenFileName(this,QString("Open disk ").append(QChar(0x41+drv)).append(":"),"","Disk images (*.trd *.scl)");
	if (fnam!="") {
		std::string sfnam(fnam.toUtf8().data());
		diskname[drv]->setText(fnam);
		loaddisk(sfnam,drv);
	}
}

void SetupWin::choosesshfolder() {
	QString folderpath = QFileDialog::getExistingDirectory(this,"Screenshots folder",QString(screenshotdir.c_str()),QFileDialog::ShowDirsOnly);
	if (folderpath!="") sshotfld->setText(folderpath);
}

// --- user men

void SetupWin::delusermen() {
	int row = menlist->currentIndex().row();
	if (row==-1) return;
	tumlist.erase(tumlist.begin()+row);
	formumlist();
}

void SetupWin::applyaddumen() {
	if (umdname->text()=="" || umdpath->text()=="") return;
	umendial->hide();
	MenuEntry newme;
	newme.name = std::string(umdname->text().toUtf8().data());
	newme.path = std::string(umdpath->text().toUtf8().data());
	if (editrow==-1) {tumlist.push_back(newme);} else {tumlist[editrow]=newme;}
	formumlist();
}

void SetupWin::selumdpath() {
	QString fnam = QFileDialog::getOpenFileName(this,"Select path","","Known formats (*.tap *.tzx *.trd *.scl *.sna)");
	if (fnam!="") umdpath->setText(fnam);
	return;
}

void SetupWin::formumlist() {
	QStringList umdsl;
	uint i;
	for (i=0;i<tumlist.size();i++) umdsl << QString(tumlist[i].name.c_str()).append("\t").append(QString(tumlist[i].path.c_str()));
	QStringListModel *model = new QStringListModel;
	model->setStringList(umdsl);
	menlist->setModel(model);
}

void SetupWin::editumen(QModelIndex idx) {
	int row = idx.row();
	if (row==-1) return;
	umdname->setText(tumlist[row].name.c_str());
	umdpath->setText(tumlist[row].path.c_str());
	editrow = row;
	umendial->show();
}

void SetupWin::addnewumen() {
	umdname->clear(); umdpath->clear();
	umendial->show();
	editrow=-1;
}