// new sound work

void ayreset() {
	for(tmp=0;tmp<16;tmp++) {ayreg[tmp]=0;}
	noisevalue=0xffff;
}

void soundtick() {
	if ((aticks!=0) and (tcount > alimit)) {alimit=tcount+aticks; alevel = !alevel;}
	if ((bticks!=0) and (tcount > blimit)) {blimit=tcount+bticks; blevel = !blevel;}
	if ((cticks!=0) and (tcount > climit)) {climit=tcount+cticks; clevel = !clevel;}
	if ((eticks!=0) and (tcount > elimit)) {
		elimit = tcount+eticks;
		envpos++;
		if (envforms[curenv][envpos]==255) envpos--;
		if (envforms[curenv][envpos]==253) envpos=0;
	}
	if ((nticks!=0) and (tcount > nlimit)) {
		nlimit = tcount+nticks;
		nlevel = (noisevalue&0x10000);
		noisevalue = ((noisevalue*2) + ((nlevel==((noisevalue&0x2000)==0x2000))?0:1))&0x1ffff;
	}
	sndtick--;
	if (sndtick>0) return;
	sndtick = ticksatbyte;
	level = (beeplevel?beepvolume:0) + ((tape.play && tape.signal)?beepvolume:0);
	if (tape.play) level += (tape.outsig?tapevolume:0);
	avol=(ayreg[8]&16)?envforms[curenv][envpos]:(ayreg[8]&15);	// значения с ЦАП'а
	bvol=(ayreg[9]&16)?envforms[curenv][envpos]:(ayreg[9]&15);
	cvol=(ayreg[10]&16)?envforms[curenv][envpos]:(ayreg[10]&15);
	if ((ayreg[7]&0x09)!=0x09) {avol *= (((ayreg[7]&1)?0:alevel)+((ayreg[7]&8)?0:nlevel));}
	if ((ayreg[7]&0x12)!=0x12) {bvol *= (((ayreg[7]&2)?0:blevel)+((ayreg[7]&16)?0:nlevel));}
	if ((ayreg[7]&0x24)!=0x24) {cvol *= (((ayreg[7]&4)?0:clevel)+((ayreg[7]&32)?0:nlevel));}
	level += (avol+bvol+cvol)*ayvolume/16.0;
	sndbufer[sndbufpos++]=level;
}

void aysetreg(unsigned char idx, unsigned char value) {
	if (idx>15) return;
	if (idx<14) ayreg[idx]=value;
	switch (idx) {
		case 0x00:
		case 0x01: aticks=aycoe*(ayreg[0]+((ayreg[1]&0x0f)<<8)); if (aticks==0) aticks=aycoe; break;
		case 0x02:
		case 0x03: bticks=aycoe*(ayreg[2]+((ayreg[3]&0x0f)<<8)); if (aticks==0) bticks=aycoe; break;
		case 0x04:
		case 0x05: cticks=aycoe*(ayreg[4]+((ayreg[5]&0x0f)<<8)); if (aticks==0) cticks=aycoe; break;
		case 0x06: nticks=2*aycoe*(value&31); break;		// ???
		case 0x0b:
		case 0x0c: eticks=2*aycoe*(ayreg[11]+(ayreg[12]<<8)); break;	// тиков смены огибающей
		case 0x0d: curenv=value; envpos=0; elimit=tcount+eticks; break;
		case 0x0e: if (ayreg[7]&0x40) ayreg[14]=value; break;
		case 0x0f: if (ayreg[7]&0x80) ayreg[15]=value; break;
	}
}

//---------------------

void defsoundparamz() {
	rate = sndfreqs[cursndfreq];
	bufsize=int(rate*chanels*sndbuflen/1000.0);
	ticksatbyte=hticks*vlines/bufsize;
	aycoe=400*hticks*vlines/float(ayfreq);
}

void addsoundsys(std::string nam, bool (*opfunc)(), void (*pfunc)(), void (*clofunc)()) {
	SoundSys newsys;
	newsys.name = nam;
	newsys.open = opfunc;
 	newsys.play = pfunc;
	newsys.close = clofunc;
	soundsyslist.push_back(newsys);
}

bool null_open() {return true;}
void null_play() {}
void null_close() {}

#ifndef WIN32

bool oss_open() {
	printf("Open OSS audio device\n");
	audio=open("/dev/dsp",O_WRONLY,0777);
	if (audio==0) return false;
	ioctl(audio,SNDCTL_DSP_CHANNELS,&chanels);	// число каналов
	ioctl(audio,SNDCTL_DSP_SETFMT,&sndformat);	// формат вывода
	ioctl(audio,SNDCTL_DSP_SPEED,&rate);		// частота дискретизации;
	return true;
}

void oss_play() {if (audio!=0) write(audio,sndbufer,sndbufpos-1);}
void oss_close() {
	if (audio==0) return;
	printf("Close OSS audio device\n");
	close(audio);
}

bool alsa_open() {
	int err;
	bool res = true;
	printf("libasound: open audio device... ");
	if ((err = snd_pcm_open(&ahandle,device,SND_PCM_STREAM_PLAYBACK,0))<0) {
		printf("playback open error: %s\n",snd_strerror(err));
		res=false;
	} else {
		printf("OK\n");
		printf("libasound: set audio paramz...");
		if ((err = snd_pcm_set_params(ahandle,SND_PCM_FORMAT_U8,SND_PCM_ACCESS_RW_INTERLEAVED,1,rate,1,100000)) < 0) {
			printf("playback open error: %s\n",snd_strerror(err)); res=false;
		} else {printf("OK\n");}
	}
	return res;
}

void alsa_play() {
	frames = snd_pcm_writei(ahandle,sndbufer,sndbufpos-1);
	if (frames<0) frames=snd_pcm_recover(ahandle,frames,0);
	if (frames<0) qDebug()<<"Playback error";
}

void alsa_close() {qDebug()<<"libasound: close device";snd_pcm_close(ahandle);}

#else

bool wave_open() {
	wfx.nSamplesPerSec = rate;
	wfx.wBitsPerSample = 8;
	wfx.nChannels = chanels;
	wfx.cbSize = 0;
	wfx.wFormatTag = WAVE_FORMAT_PCM;
	wfx.nBlockAlign = wfx.nChannels;
	wfx.nAvgBytesPerSec = wfx.nBlockAlign * wfx.nSamplesPerSec;
	if (waveOutOpen(&hwaveout,WAVE_MAPPER,&wfx,0,0,CALLBACK_NULL) != MMSYSERR_NOERROR) {
		printf("Can't open wave out device\n");
		return false;
	}
	whdr.lpData = (CHAR*)&sndbufer[0];
	whdr.dwBufferLength = bufsize;
	whdr.dwFlags = WHDR_PREPARED;
	whdr.dwLoops = 0;
	waveOutPrepareHeader(hwaveout,&whdr,sizeof(whdr));
	return true;
}

void wave_play() {
	if (hwaveout!=NULL) {
		waveOutWrite(hwaveout,&whdr,sizeof(whdr));
	}
}
void wave_close() {waveOutClose(hwaveout);}

#endif